import 'dart:convert';

class User {
  final String id;
  final bool changePassword;
  final String? photo;
  final List<dynamic> properties;
  final bool admin;
  final bool allowedToChangePassword;
  final String username;
  final String fullName;
  final String? description;
  final String email;
  final String tenantName;
  final String tenantDomain;
  final String tenantLocale;
  final bool blocked;
  final String authenticationType;
  final String _discriminator;

  User({
    required this.id,
    required this.changePassword,
    required this.properties,
    required this.admin,
    required this.allowedToChangePassword,
    required this.username,
    required this.fullName,
    required this.email,
    required this.tenantName,
    required this.tenantDomain,
    required this.tenantLocale,
    required this.blocked,
    required this.authenticationType,
    required String discriminator,
    this.description,
    this.photo,
  }) : _discriminator = discriminator;

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'changePassword': changePassword,
      'photo': photo,
      'properties': properties,
      'admin': admin,
      'allowedToChangePassword': allowedToChangePassword,
      'fullName': fullName,
      'username': username,
      'description': description,
      'email': email,
      'tenantDomain': tenantDomain,
      'tenantName': tenantName,
      'tenantLocale': tenantLocale,
      'blocked': blocked,
      'authenticationType': authenticationType,
      '_discriminator': _discriminator
    };
  }

  String toJson() => json.encode(toMap());

  factory User.fromMap(Map<String, dynamic> map) {
    return User(
        id: map['id'],
        changePassword: map['changePassword'],
        photo: map['photo'],
        properties: map['properties'],
        admin: map['admin'],
        allowedToChangePassword: map['allowedToChangePassword'],
        fullName: map['fullName'],
        username: map['username'],
        description: map['description'],
        email: map['email'],
        tenantDomain: map['tenantDomain'],
        tenantName: map['tenantName'],
        tenantLocale: map['tenantLocale'],
        blocked: map['blocked'],
        authenticationType: map['authenticationType'],
        discriminator: map['_discriminator']);
  }

  factory User.fromJson(String source) => User.fromMap(json.decode(source));
}
